package com.ruoyi.postCheck.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * 岗检问题操作记录表对象 post_checked_problem_record
 *
 * @author csg
 * @date 2023-12-23
 */
@Data
@ApiModel(value = "岗检问题操作记录表对象")
@TableName("post_checked_problem_record") // 数据库表名
public class PostCheckedProblemRecord implements Serializable {

    private static final long serialVersionUID = -4756232795398301874L;
    private Long id;

    @ApiModelProperty("问题ID")
    @TableField(value = "problem_id")
    @Excel(name = "问题ID", readConverterExp = "多=")
    private Long problemId;

    @ApiModelProperty("操作者姓名")
    @TableField(value = "user_by")
    @Excel(name = "操作者姓名")
    private String userBy;

    @ApiModelProperty("操作内容")
    @TableField(value = "content")
    @Excel(name = "操作内容")
    private String content;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "create_time")
    private Date createTime;
}
