package com.ruoyi.postCheck.domain;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 岗检报告管理对象 post_checked_report
 *
 * @author csg
 * @date 2023-12-28
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(value = "岗检报告管理对象")
@TableName("post_checked_report") // 数据库表名
public class PostCheckedReport extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty("编码")
    @TableField(value = "report_no")
    @Excel(name = "编码")
    private String reportNo;

    @ApiModelProperty("岗检报告名称")
    @TableField(value = "report_name")
    @Excel(name = "岗检报告名称")
    private String reportName;

    @ApiModelProperty("前言")
    @TableField(value = "report_preface")
    @Excel(name = "前言")
    private String reportPreface;

//    @ApiModelProperty("废弃：完善性问题")
//    @TableField(value = "consummation_problem")
//    @Excel(name = "废弃：完善性问题")
//    private Integer consummationProblem;

//    @ApiModelProperty("废弃：适宜性问题")
//    @TableField(value = "suitability_problem")
//    @Excel(name = "废弃：适宜性问题")
//    private Integer suitabilityProblem;

//    @ApiModelProperty("废弃：有效性问题")
//    @TableField(value = "effectiveness_problem")
//    @Excel(name = "废弃：有效性问题")
//    private Integer effectivenessProblem;

//    @ApiModelProperty("废弃：立行立改问题数量")
//    @TableField(value = "li_xing_li_gai_question_number")
//    @Excel(name = "废弃：立行立改问题数量")
//    private Integer liXingLiGaiQuestionNumber;

//    @ApiModelProperty("废弃：立行立改问题已整改数量")
//    @TableField(value = "li_xing_li_gai_question_has_rectified_number")
//    @Excel(name = "废弃：立行立改问题已整改数量")
//    private Integer liXingLiGaiQuestionHasRectifiedNumber;

//    @ApiModelProperty("废弃：富文本")
//    @TableField(value = "rich_text")
//    @Excel(name = "废弃：富文本")
//    private String richText;

    @ApiModelProperty("生成时间")
    @TableField(value = "generate_time")
    @Excel(name = "生成时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date generateTime;

    @ApiModelProperty("创建者用户ID")
    @TableField(value = "create_user_id")
    @Excel(name = "创建者用户ID")
    private Long createUserId;

    @ApiModelProperty("1、（一）组织情况")
    @TableField(value = "html_one")
    @Excel(name = "1、", readConverterExp = "一=")
    private String htmlOne;

    @ApiModelProperty("2、（二）岗检的时间、范围和开展形式")
    @TableField(value = "html_two")
    @Excel(name = "2、（二）岗检的时间、范围和开展形式")
    private String htmlTwo;

    @ApiModelProperty("3、（三）岗检发现的主要问题")
    @TableField(value = "html_three")
    @Excel(name = "3、（三）岗检发现的主要问题")
    private String htmlThree;

    @ApiModelProperty("4、（四）原因分析")
    @TableField(value = "html_four")
    @Excel(name = "4、（四）原因分析")
    private String htmlFour;

    @ApiModelProperty("5、（五）取得成绩")
    @TableField(value = "html_five")
    @Excel(name = "5、（五）取得成绩")
    private String htmlFive;

    @ApiModelProperty("6、（一）“立行立改”问题整改情况")
    @TableField(value = "html_six")
    @Excel(name = "6、（一）“立行立改”问题整改情况")
    private String htmlSix;

    @ApiModelProperty("7、（二）“非立行立改”问题整改情况")
    @TableField(value = "html_seven")
    @Excel(name = "7、（二）“非立行立改”问题整改情况")
    private String htmlSeven;

    @ApiModelProperty("8、三、下一步岗位责任提升计划")
    @TableField(value = "html_eight")
    @Excel(name = "8、三、下一步岗位责任提升计划")
    private String htmlEight;

    @ApiModelProperty("9、四、总结结论")
    @TableField(value = "html_nine")
    @Excel(name = "9、四、总结结论")
    private String htmlNine;

    @ApiModelProperty("状态：1-待审核；3-通过；4-驳回；")
    @TableField(value = "status")
    @Excel(name = "状态：1-待审核；3-通过；4-驳回；")
    private Integer status;

    @ApiModelProperty("审核人ID")
    @TableField(value = "status_by_user_id")
    @Excel(name = "审核人ID")
    private Long statusByUserId;

    @ApiModelProperty("审核人姓名")
    @TableField(value = "status_by_user_name")
    @Excel(name = "审核人姓名")
    private String statusByUserName;

    @ApiModelProperty("审核不通过原因")
    @TableField(value = "status_reason")
    @Excel(name = "审核不通过原因")
    private String statusReason;

    @ApiModelProperty("审核不通过时间")
    @TableField(value = "status_approve_time")
    @Excel(name = "审核不通过时间")
    private Date statusApproveTime;

    @ApiModelProperty("开始时间-统计范围")
    @TableField(value = "start_time")
    @Excel(name = "开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date startTime;

    @ApiModelProperty("结束时间-统计范围")
    @TableField(value = "end_time")
    @Excel(name = "结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date endTime;

    @ApiModelProperty("类型：1-综合岗检工作组（职能部门）;2-生产岗检工作组（生产部门）;3-联合办公室；")
    @TableField(value = "type")
    @Excel(name = "类型")
    private Integer type;

}
