package com.ruoyi.postCheck.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

/**
 * 岗检责任制清单明细对象 post_list_info
 *
 * @author csg
 * @date 2023-12-20
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(value = "岗检责任制清单明细对象")
@TableName("post_list_info") // 数据库表名
public class PostListInfo extends BaseEntity
{
    private static final long serialVersionUID = 1L;
    private Long id;

    @ApiModelProperty("分区域审核-状态：1-待审核；3-通过；4-驳回；")
    @TableField(value = "status")
    @Excel(name = "分区域审核-状态：1-待审核；3-通过；4-驳回；")
    private Integer status;

    @ApiModelProperty("状态更新时间")
    @TableField(value = "status_time")
    @Excel(name = "状态更新时间")
    private Date statusTime;

    @ApiModelProperty("审核人ID")
    @TableField(value = "status_by_user_id")
    @Excel(name = "审核人ID")
    private Long statusByUserId;

    @ApiModelProperty("审核人姓名")
    @TableField(value = "status_by_user_name")
    @Excel(name = "审核人姓名")
    private String statusByUserName;

    @ApiModelProperty("未通过理由")
    @TableField(value = "reason")
    @Excel(name = "未通过理由")
    private String reason;

    @ApiModelProperty("岗位责任制清单表ID")
    @TableField(value = "post_list_id")
    @Excel(name = "岗位责任制清单表ID", readConverterExp = "多=")
    private Long postListId;

    @ApiModelProperty("类型")
    @TableField(value = "type")
    @Excel(name = "类型", readConverterExp = "1=-业务职责；2-党建及党风廉政建设职责；3-安全环保职责；4-合规保密职；5-任职资格与能力素质要求")
    private Integer type;

    @ApiModelProperty("序号/项目")
    @TableField(value = "sequence_project")
    @Excel(name = "序号/项目", readConverterExp = "1=、2")
    private String sequenceProject;

    @ApiModelProperty("一级事项")
    @TableField(value = "level_one")
    @Excel(name = "一级事项", readConverterExp = "1=")
    private String levelOne;

    @ApiModelProperty("二级事项")
    @TableField(value = "level_two")
    @Excel(name = "二级事项", readConverterExp = "1=")
    private String levelTwo;

    @ApiModelProperty("三级事项")
    @TableField(value = "level_three")
    @Excel(name = "三级事项", readConverterExp = "1=")
    private String levelThree;

    @ApiModelProperty("四级事项")
    @TableField(value = "level_four")
    @Excel(name = "四级事项", readConverterExp = "1=")
    private String levelFour;

    @ApiModelProperty("五级事项")
    @TableField(value = "level_five")
    @Excel(name = "五级事项", readConverterExp = "1=")
    private String levelFive;

    @ApiModelProperty("工作标准")
    @TableField(value = "work_standard")
    @Excel(name = "工作标准", readConverterExp = "1=")
    private String workStandard;

    @ApiModelProperty("要求")
    @TableField(value = "requirement")
    @Excel(name = "要求", readConverterExp = "2=")
    private String requirement;

    @ApiModelProperty("创建者用户ID")
    @TableField(value = "create_user_id")
    @Excel(name = "创建者用户ID")
    private Long createUserId;



}
