package com.ruoyi.postCheck.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 岗检计划明细检查人表对象 post_plan_check_user
 *
 * @author csg
 * @date 2023-12-19
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(value = "岗检计划明细检查人表对象")
@TableName("post_plan_check_user") // 数据库表名
public class PostPlanCheckUser extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty("计划明细ID")
    @TableField(value = "post_plan_id")
    @Excel(name = "计划明细ID")
    private Long postPlanId;

    @ApiModelProperty("检查人员ID")
    @TableField(value = "checked_user_id")
    @Excel(name = "检查人员ID")
    private Long checkedUserId;

    @ApiModelProperty("创建者用户ID")
    @TableField(value = "create_user_id")
    @Excel(name = "创建者用户ID")
    private Long createUserId;

    @ApiModelProperty("检查人员ID：1-组长；2-组员；")
    @TableField(value = "type")
    @Excel(name = "检查人员ID：1-组长；2-组员；")
    private Integer type;

}
