package com.ruoyi.postCheck.domain.problemStatistics;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@EqualsAndHashCode
@Data
@ApiModel(value = "统计分析-岗检问题职责类别占比（职能管理）")
public class DutyTypeProblemStatisticsView implements Serializable {


    private static final long serialVersionUID = -6982314157222524166L;
    @ApiModelProperty("业务职责")
    private Integer dutyTypeOne;

    @ApiModelProperty("党建及党风廉政")
    private Integer dutyTypeTwo;

    @ApiModelProperty("安全环保职责")
    private Integer dutyTypeThree;

    @ApiModelProperty("合规保密职")
    private Integer dutyTypeFour;

    /**
     * @ApiModelProperty("完整性数量") private Integer problemComplete;
     * @ApiModelProperty("适宜性数量") private Integer problemSuitable;
     * @ApiModelProperty("有效性数量") private Integer problemEffective;
     * @ApiModelProperty("已完成完整性数量") private Integer problemCompleteChecked;
     * @ApiModelProperty("已完成适宜性数量") private Integer problemSuitableChecked;
     * @ApiModelProperty("已完成有效性数量") private Integer problemEffectiveChecked;
     */
    @ApiModelProperty("problem_attribute 问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）")
    private List<ProblemAttributeInner> children = new ArrayList<>();

    public static class ProblemAttributeInner extends ProblemNumberBase {

        private static final long serialVersionUID = -5709957331615760177L;
        @ApiModelProperty("已完成完整性数量")
        private Integer problemCompleteChecked;
        @ApiModelProperty("已完成适宜性数量")
        private Integer problemSuitableChecked;
        @ApiModelProperty("已完成有效性数量")
        private Integer problemEffectiveChecked;

    }

}
