package com.ruoyi.postCheck.mapper;

import java.util.List;
import com.ruoyi.postCheck.domain.PostAssessmentRules;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * 考核规则Mapper接口
 *
 * @author csg
 * @date 2023-12-28
 */
public interface PostAssessmentRulesMapper extends BaseMapper<PostAssessmentRules>
{
    /**
     * 查询考核规则
     *
     * @param id 考核规则主键
     * @return 考核规则
     */
    public PostAssessmentRules selectPostAssessmentRulesById(Long id);

    /**
     * 查询考核规则列表
     *
     * @param postAssessmentRules 考核规则
     * @return 考核规则集合
     */
    public List<PostAssessmentRules> selectPostAssessmentRulesList(PostAssessmentRules postAssessmentRules);

    /**
     * 新增考核规则
     *
     * @param postAssessmentRules 考核规则
     * @return 结果
     */
    public int insertPostAssessmentRules(PostAssessmentRules postAssessmentRules);

    /**
     * 修改考核规则
     *
     * @param postAssessmentRules 考核规则
     * @return 结果
     */
    public int updatePostAssessmentRules(PostAssessmentRules postAssessmentRules);

    /**
     * 删除考核规则
     *
     * @param id 考核规则主键
     * @return 结果
     */
    public int deletePostAssessmentRulesById(Long id);

    /**
     * 批量删除考核规则
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePostAssessmentRulesByIds(Long[] ids);
}
