package com.ruoyi.postCheck.mapper;

import java.util.List;
import com.ruoyi.postCheck.domain.PostCheckedItems;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * 岗检表管理明细Mapper接口
 *
 * @author csg
 * @date 2024-01-05
 */
public interface PostCheckedItemsMapper extends BaseMapper<PostCheckedItems>
{
    /**
     * 查询岗检表管理明细
     *
     * @param id 岗检表管理明细主键
     * @return 岗检表管理明细
     */
    public PostCheckedItems selectPostCheckedItemsById(Long id);

    /**
     * 查询岗检表管理明细列表
     *
     * @param postCheckedItems 岗检表管理明细
     * @return 岗检表管理明细集合
     */
    public List<PostCheckedItems> selectPostCheckedItemsList(PostCheckedItems postCheckedItems);

    /**
     * 新增岗检表管理明细
     *
     * @param postCheckedItems 岗检表管理明细
     * @return 结果
     */
    public int insertPostCheckedItems(PostCheckedItems postCheckedItems);

    /**
     * 修改岗检表管理明细
     *
     * @param postCheckedItems 岗检表管理明细
     * @return 结果
     */
    public int updatePostCheckedItems(PostCheckedItems postCheckedItems);

    /**
     * 删除岗检表管理明细
     *
     * @param id 岗检表管理明细主键
     * @return 结果
     */
    public int deletePostCheckedItemsById(Long id);

    /**
     * 批量删除岗检表管理明细
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePostCheckedItemsByIds(Long[] ids);
}
