package com.ruoyi.postCheck.mapper;

import java.util.List;
import com.ruoyi.postCheck.domain.PostListInfo;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * 岗检责任制清单明细Mapper接口
 *
 * @author csg
 * @date 2023-12-20
 */
public interface PostListInfoMapper extends BaseMapper<PostListInfo>
{
    /**
     * 查询岗检责任制清单明细
     *
     * @param id 岗检责任制清单明细主键
     * @return 岗检责任制清单明细
     */
    public PostListInfo selectPostListInfoById(Long id);

    /**
     * 查询岗检责任制清单明细列表
     *
     * @param postListInfo 岗检责任制清单明细
     * @return 岗检责任制清单明细集合
     */
    public List<PostListInfo> selectPostListInfoList(PostListInfo postListInfo);

    /**
     * 新增岗检责任制清单明细
     *
     * @param postListInfo 岗检责任制清单明细
     * @return 结果
     */
    public int insertPostListInfo(PostListInfo postListInfo);

    /**
     * 修改岗检责任制清单明细
     *
     * @param postListInfo 岗检责任制清单明细
     * @return 结果
     */
    public int updatePostListInfo(PostListInfo postListInfo);

    /**
     * 删除岗检责任制清单明细
     *
     * @param id 岗检责任制清单明细主键
     * @return 结果
     */
    public int deletePostListInfoById(Long id);

    /**
     * 批量删除岗检责任制清单明细
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePostListInfoByIds(Long[] ids);
}
