package com.ruoyi.postCheck.mapper;

import java.util.List;
import com.ruoyi.postCheck.domain.PostProgrammeTemplate;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * 岗检方案模板Mapper接口
 *
 * @author csg
 * @date 2023-12-19
 */
public interface PostProgrammeTemplateMapper extends BaseMapper<PostProgrammeTemplate>
{
    /**
     * 查询岗检方案模板
     *
     * @param id 岗检方案模板主键
     * @return 岗检方案模板
     */
    public PostProgrammeTemplate selectPostProgrammeTemplateById(Long id);

    /**
     * 查询岗检方案模板列表
     *
     * @param postProgrammeTemplate 岗检方案模板
     * @return 岗检方案模板集合
     */
    public List<PostProgrammeTemplate> selectPostProgrammeTemplateList(PostProgrammeTemplate postProgrammeTemplate);

    /**
     * 新增岗检方案模板
     *
     * @param postProgrammeTemplate 岗检方案模板
     * @return 结果
     */
    public int insertPostProgrammeTemplate(PostProgrammeTemplate postProgrammeTemplate);

    /**
     * 修改岗检方案模板
     *
     * @param postProgrammeTemplate 岗检方案模板
     * @return 结果
     */
    public int updatePostProgrammeTemplate(PostProgrammeTemplate postProgrammeTemplate);

    /**
     * 删除岗检方案模板
     *
     * @param id 岗检方案模板主键
     * @return 结果
     */
    public int deletePostProgrammeTemplateById(Long id);

    /**
     * 批量删除岗检方案模板
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePostProgrammeTemplateByIds(Long[] ids);
}
