package com.ruoyi.postCheck.service;

import java.util.List;
import com.ruoyi.postCheck.domain.PostProgrammeTemplate;
import com.baomidou.mybatisplus.extension.service.IService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

/**
 * 岗检方案模板Service接口
 *
 * @author csg
 * @date 2023-12-19
 */
public interface IPostProgrammeTemplateService extends IService<PostProgrammeTemplate>
{
    /**
     * 查询岗检方案模板
     *
     * @param id 岗检方案模板主键
     * @return 岗检方案模板
     */
    public PostProgrammeTemplate selectPostProgrammeTemplateById(Long id);

    /**
     * 查询岗检方案模板列表
     *
     * @param postProgrammeTemplate 岗检方案模板
     * @return 岗检方案模板集合
     */
    public List<PostProgrammeTemplate> selectPostProgrammeTemplateList(PostProgrammeTemplate postProgrammeTemplate);

    /**
     * 新增岗检方案模板
     *
     * @param postProgrammeTemplate 岗检方案模板
     * @return 结果
     */
    public int insertPostProgrammeTemplate(PostProgrammeTemplate postProgrammeTemplate);

    /**
     * 修改岗检方案模板
     *
     * @param postProgrammeTemplate 岗检方案模板
     * @return 结果
     */
    public int updatePostProgrammeTemplate(PostProgrammeTemplate postProgrammeTemplate);

    /**
     * 批量删除岗检方案模板
     *
     * @param ids 需要删除的岗检方案模板主键集合
     * @return 结果
     */
    public int deletePostProgrammeTemplateByIds(Long[] ids);

    /**
     * 删除岗检方案模板信息
     *
     * @param id 岗检方案模板主键
     * @return 结果
     */
    public int deletePostProgrammeTemplateById(Long id);

    /**
     * 审核：岗检方案模板启用/禁用
     * @param id 主键ID
     * @param status 状态（1-启动；2-作废）
     * @return
     */
    int approve(Long id, Integer status);
}
